package com.ekexiu.project.storage.dicom;

import java.io.File;
import java.io.IOException;
import java.security.GeneralSecurityException;
import java.util.Collections;
import java.util.List;

import org.dcm4che3.net.IncompatibleConnectionException;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;

@Path("/dicom")
public class DicomService {
	private String localTitle="AIADS";
	private String remoteTitle="STPACS";
	private String remoteHostName ="133.0.14.150";
	private int remotePort = 104;
	private File storagePath = new File("/ekexiu/storage_asd/download");
	
	
	public String getLocalTitle() {
		return localTitle;
	}
	public void setLocalTitle(String localTitle) {
		this.localTitle = localTitle;
	}
	public String getRemoteTitle() {
		return remoteTitle;
	}
	public void setRemoteTitle(String remoteTitle) {
		this.remoteTitle = remoteTitle;
	}
	public String getRemoteHostName() {
		return remoteHostName;
	}
	public void setRemoteHostName(String remoteHostName) {
		this.remoteHostName = remoteHostName;
	}
	public int getRemotePort() {
		return remotePort;
	}
	public void setRemotePort(int remotePort) {
		this.remotePort = remotePort;
	}
	public File getStoragePath() {
		return storagePath;
	}
	public void setStoragePath(File storagePath) {
		this.storagePath = storagePath;
	}
	
	@Get
	@Path("/study")
	public List<PatientStudy> queryStudy(@Nullable String name,@Nullable String id) throws IOException, InterruptedException, IncompatibleConnectionException, GeneralSecurityException{
		if(name != null || id !=null){
			DicomQueryStudy query = new DicomQueryStudy(this.localTitle);
			return query.query(this.remoteTitle, remoteHostName, remotePort,name,id);
		}else{
			return Collections.emptyList();
		}
	} 
	@Get
	@Path("/series")
	public List<StudySeries> querySeries(String id) throws IOException, InterruptedException, IncompatibleConnectionException, GeneralSecurityException{
			DicomQuerySeries query = new DicomQuerySeries(this.localTitle);
			return query.query(this.remoteTitle, remoteHostName, remotePort,id);
	} 
	
	@Get
	@Path("/image")
	public List<SeriesImage> queryImage(String study,String series) throws IOException, InterruptedException, IncompatibleConnectionException, GeneralSecurityException{
			DicomQueryImage query = new DicomQueryImage(this.localTitle);
			return query.query(this.remoteTitle, remoteHostName, remotePort,study,series);
	} 
	
	@Get
	@Path("/download")
	public boolean download(String id) throws IOException, InterruptedException, IncompatibleConnectionException, GeneralSecurityException{
		DicomGetImage q = new DicomGetImage(this.localTitle);
		return null !=q.download(this.remoteTitle, remoteHostName, remotePort,id,this.storagePath,id+".dcm");
	}
	
	
	
	
	
	
	
	
	

}
